# Generated by sila2.code_generator; sila2.__version__: 0.9.2
from __future__ import annotations

from abc import ABC, abstractmethod
from datetime import datetime
from queue import Queue
from typing import TYPE_CHECKING, Optional, Union

from sila2.server import FeatureImplementationBase, MetadataDict

from .temperaturecontroller_types import SetMaxTemperature_Responses, SetMinTemperature_Responses

if TYPE_CHECKING:
    from ...server import Server


class TemperatureControllerBase(FeatureImplementationBase, ABC):
    parent_server: Server

    _CurrentTemperature_producer_queue: Queue[Union[float, Exception]]
    _CurrentTemperature_current_value: float

    _CurrentTimestamp_producer_queue: Queue[Union[datetime, Exception]]
    _CurrentTimestamp_current_value: datetime

    def __init__(self, parent_server: Server):
        """

        Controlling the temperature with a simple thermostat-like device.
        Very simplified version of the TemperatureController developed by Stefan Koch or Maximilian Schulz ?

        """
        super().__init__(parent_server=parent_server)

        self._CurrentTemperature_producer_queue = Queue()

        self._CurrentTimestamp_producer_queue = Queue()

    def update_CurrentTemperature(self, CurrentTemperature: float, queue: Optional[Queue[float]] = None) -> None:
        """
        Current Temperature as measured by the controller in Kelvin.

        This method updates the observable property 'CurrentTemperature'.

        :param queue: The queue to send updates to. If None, the default Queue will be used.
        """
        if queue is None:
            queue = self._CurrentTemperature_producer_queue
            self._CurrentTemperature_current_value = CurrentTemperature
        queue.put(CurrentTemperature)

    def CurrentTemperature_on_subscription(self, *, metadata: MetadataDict) -> Optional[Queue[float]]:
        """
        Current Temperature as measured by the controller in Kelvin.

        This method is called when a client subscribes to the observable property 'CurrentTemperature'

        :param metadata: The SiLA Client Metadata attached to the call
        :return: Optional `Queue` that should be used for updating this property.
            If None, the default Queue will be used.
        """
        pass

    def abort_CurrentTemperature_subscriptions(self, error: Exception, queue: Optional[Queue[float]] = None) -> None:
        """
        Current Temperature as measured by the controller in Kelvin.

        This method aborts subscriptions to the observable property 'CurrentTemperature'.

        :param error: The Exception to be sent to the subscribing client.
            If it is no DefinedExecutionError or UndefinedExecutionError, it will be wrapped in an UndefinedExecutionError.
        :param queue: The queue to abort. If None, the default Queue will be used.
        """
        if queue is None:
            queue = self._CurrentTemperature_producer_queue
        queue.put(error)

    @property
    def current_CurrentTemperature(self) -> float:
        try:
            return self._CurrentTemperature_current_value
        except AttributeError:
            raise AttributeError("Observable property CurrentTemperature has never been set")

    def update_CurrentTimestamp(self, CurrentTimestamp: datetime, queue: Optional[Queue[datetime]] = None) -> None:
        """
        Current Timestamp in ISO timestamp format

        This method updates the observable property 'CurrentTimestamp'.

        :param queue: The queue to send updates to. If None, the default Queue will be used.
        """
        if queue is None:
            queue = self._CurrentTimestamp_producer_queue
            self._CurrentTimestamp_current_value = CurrentTimestamp
        queue.put(CurrentTimestamp)

    def CurrentTimestamp_on_subscription(self, *, metadata: MetadataDict) -> Optional[Queue[datetime]]:
        """
        Current Timestamp in ISO timestamp format

        This method is called when a client subscribes to the observable property 'CurrentTimestamp'

        :param metadata: The SiLA Client Metadata attached to the call
        :return: Optional `Queue` that should be used for updating this property.
            If None, the default Queue will be used.
        """
        pass

    def abort_CurrentTimestamp_subscriptions(self, error: Exception, queue: Optional[Queue[datetime]] = None) -> None:
        """
        Current Timestamp in ISO timestamp format

        This method aborts subscriptions to the observable property 'CurrentTimestamp'.

        :param error: The Exception to be sent to the subscribing client.
            If it is no DefinedExecutionError or UndefinedExecutionError, it will be wrapped in an UndefinedExecutionError.
        :param queue: The queue to abort. If None, the default Queue will be used.
        """
        if queue is None:
            queue = self._CurrentTimestamp_producer_queue
        queue.put(error)

    @property
    def current_CurrentTimestamp(self) -> datetime:
        try:
            return self._CurrentTimestamp_current_value
        except AttributeError:
            raise AttributeError("Observable property CurrentTimestamp has never been set")

    @abstractmethod
    def SetMaxTemperature(self, MaxTemperature: float, *, metadata: MetadataDict) -> SetMaxTemperature_Responses:
        """
        Set the Maximum Temperature of the thermostat


        :param MaxTemperature:
                The target temperature that the server will try to reach.
                Note that the command might be completed at a temperature that it evaluates to be close enough.


        :param metadata: The SiLA Client Metadata attached to the call

        :return:

            - MaxTemperatureSet: Max Temperature succeeded to Set (Bool).


        """
        pass

    @abstractmethod
    def SetMinTemperature(self, MinTemperature: float, *, metadata: MetadataDict) -> SetMinTemperature_Responses:
        """
        Set the Minimum Temperature of the thermostat


        :param MinTemperature:
                The target temperature that the server will try to reach.
                Note that the command might be completed at a temperature that it evaluates to be close enough.


        :param metadata: The SiLA Client Metadata attached to the call

        :return:

            - MinTemperatureSet: Min Temperature succeeded to Set (Bool).


        """
        pass
